package gui.keyboard;

import gui.run.RunButton;
import gui.touchtone.TouchToneButtonPad;
import gui.touchtone.TouchToneModel;
import gui.layouts.VerticalFlowLayout;

import javax.swing.*;
import java.awt.*;

// gui.keyboard.KeyTest

public class KeyTestFrame extends gui.ClosableJFrame {

    public static void main(String args[]) {
        KeyTestFrame ktf = new KeyTestFrame();
        final TouchToneModel ttm =
                new TouchToneModel();
        JPanel jp = new JPanel();
        new TouchToneButtonPad(jp, ttm);
        Container c = ktf.getContentPane();
        c.setLayout(new BorderLayout());
        c.add(jp,BorderLayout.CENTER);
        c.add(ttm.getTextField(), BorderLayout.NORTH);
        c.add(new LetterPanel(ttm),BorderLayout.EAST);
        ktf.setSize(300, 300);
        ktf.setVisible(true);

    }

    private static class LetterPanel extends JPanel {
        private final TouchToneModel ttm;
        private final MyRunButton enterButton;

        public LetterPanel(TouchToneModel ttm) {
            setLayout(new GridLayout(0,1));
            // If you use lower case, then alter
            // the DTMF tones to the 1633 Hz frequence
            addButton("a");
            addButton("b");
            addButton("c");
            addButton("d");
            enterButton = new MyRunButton("Enter");
            add(enterButton);
            this.ttm = ttm;
        }

        private void addButton(String label) {
            add(new RunButton(label){
                public void run(){
                     ttm.dialPadKey(getText());
                }
            });
        }


        private class MyRunButton extends RunButton {
            public MyRunButton(String label) {
                super(label);
            }

            public void run() {
                System.out.println(ttm.getStateString());
            }
        }
    }
}